library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.ALL;

entity p08_multiplikation_bench is
end p08_multiplikation_bench;

architecture Behavioral of p08_multiplikation_bench is

component p08_multiplikation is Port(
	clk : in std_logic;
	f1 : in std_logic_vector(3 downto 0);
	f2 : in std_logic_vector(3 downto 0);
	p : out std_logic_vector(7 downto 0);
	start: in std_logic;
	busy : out std_logic);
end component;

component p08_multiplikation_pipeline is Port(
	clk : in std_logic;
	f1 : in std_logic_vector(3 downto 0);
	f2 : in std_logic_vector(3 downto 0);
	p : out std_logic_vector(7 downto 0));
end component;

signal clk: std_logic:='0';
signal a: std_logic_vector(3 downto 0):=(others => '0');
signal b: std_logic_vector(3 downto 0):=(others => '1');
signal a_mal_b: std_logic_vector(7 downto 0):=(others => '0');
signal start: std_logic:='0';
signal busy: std_logic:='0';
signal c: std_logic_vector(3 downto 0):=(others => '0');
signal d: std_logic_vector(3 downto 0):=(others => '1');
signal c_mal_d: std_logic_vector(7 downto 0):=(others => '0');

signal rauschen: std_logic_vector(31 downto 0):=(others => '0');

begin

mult: p08_multiplikation port map(
	clk => clk,
	f1 => a,
	f2 => b,
	p => a_mal_b,
	start => start,
	busy => busy);
	
mult_pipe: p08_multiplikation_pipeline port map(
	clk => clk,
	f1 => c,
	f2 => d,
	p => c_mal_d);
	
clk <= not clk after 5 ns;

process begin
	wait until rising_edge(clk);
	rauschen(31 downto 1) <= rauschen(30 downto 0) ;
	rauschen(0) <= not(rauschen(31) xor rauschen(22) xor rauschen(2) xor rauschen(1));
end process;

process begin
	wait until rising_edge(clk);
	start <= '0';
	
	if busy = '0' and rauschen(0) = '1' then
		a <= std_logic_vector(unsigned(a) +1);
		b <= std_logic_vector(unsigned(b) -1);
		start <= '1';
	end if;
end process;

process begin
	wait until rising_edge(clk);
		c <= std_logic_vector(unsigned(c) +1);
		d <= std_logic_vector(unsigned(d) -1);
end process;

end Behavioral;